#include <stdio.h>
#include <stdlib.h>


struct atomo {
       int dato;
       struct atomo *next;
       };
 struct coda {
        struct atomo *primo;
        struct atomo *ultimo;
        };
        
int test_coda_vuota(struct coda Q)
{
    if(Q.primo==NULL)
       return 1;
    else return 0;
}

int primo_coda (struct coda Q)
{ /* da invocare solo se la coda non e' vuota*/
   return Q.primo->dato;
}

void in_coda (struct coda *pQ, int x)
{
     struct atomo *aux;

     /* creazione dell'elemento da inserire in coda*/
     aux=(struct atomo *) malloc(sizeof(struct atomo));
     if(aux==NULL)
        return;
     aux->dato=x;
     aux->next=NULL;
     if(test_coda_vuota(*pQ)==1)
      /* se la coda e' vuota */
          pQ->primo=aux;
     else pQ->ultimo->next=aux;
     
     pQ->ultimo=aux;
}

void out_coda(struct coda *pQ)
{
     struct atomo *aux;
     
     if(test_coda_vuota(*pQ)==1)
      /* coda vuota */
       {  printf("Coda vuota\n");
          return;
       }
       
      aux=pQ->primo;
      pQ->primo=aux->next;
      free(aux);
      if(pQ->primo==NULL)
          pQ->ultimo=NULL;
     
}

void visualizza_coda(struct coda Q)
{
     struct atomo *l;
     
     l=Q.primo;
     while(l!=NULL)
      {
        printf("%d\n",l->dato);
        l=l->next;
      }
}
     
     
main() {
       struct coda Q;
       int x, scelta;
       
       /* inizializzazione coda */
       Q.primo=NULL;
       Q.ultimo=NULL;
       
       do {
           printf("\nScegli tra\n");
           printf("1) Primo coda\n");
           printf("2) In coda\n");
           printf("3) Out coda\n");
           printf("4) visualizza coda\n");
           printf("0) fine\n");
           scanf("%d",&scelta);
           switch(scelta) {
            case 1:  /* visualizzazione primo */
                     if(test_coda_vuota(Q)==0)
                        printf("Il primo e': %d\n",primo_coda(Q));
                     else printf("La coda e' vuota\n");
                     break;
            case 2:  /* in coda */
                     printf("Elemento da inserire in coda\n");
                     scanf("%d",&x);
                     in_coda(&Q,x);
                     break;
            case 3:  /* out coda */  
                     out_coda(&Q);
                     break;
            case 4:  visualizza_coda(Q);
                     break;
            default:; }
       } while(scelta!=0);
     
     /* liberiamo la memoria */
     while(test_coda_vuota(Q)==0)
     /* fino a quando la coda non e' vuota */
        out_coda(&Q);
}          
       
     
     
     





        











